org.apache.sysds.runtime.compress.bitmap

## Class ABitmap

- java.lang.Object
- - org.apache.sysds.runtime.compress.bitmap.ABitmap

Direct Known Subclasses:
  Bitmap, MultiColBitmap

    public abstract class ABitmap
    extends Object

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`boolean` `containsZero()`
`abstract int` `getNumColumns()`
`abstract int` `getNumNonZerosInOffset(int idx)`
`long` `getNumOffsets()`
`int` `getNumOffsets(int ix)` Get the number of offsets for a specific unique offset.
`abstract int` `getNumValues()` Obtain number of distinct value groups in the column.
`int` `getNumZeros()`
`IntArrayList[]` `getOffsetList()`
`IntArrayList` `getOffsetsList(int idx)`
`boolean` `isEmpty()`
`abstract void` `sortValuesByFrequency()`
`String` `toString()`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### isEmpty

    public final boolean isEmpty()

#### getOffsetList

    public final IntArrayList[] getOffsetList()

#### getOffsetsList

    public final IntArrayList getOffsetsList(int idx)

#### getNumOffsets

    public final long getNumOffsets()

#### getNumOffsets

    public final int getNumOffsets(int ix)

Get the number of offsets for a specific unique offset.

Parameters:
  `ix` - The offset index.
Returns:
  The number of offsets for this unique value.

#### getNumZeros

    public final int getNumZeros()

#### containsZero

    public final boolean containsZero()

#### getNumValues

    public abstract int getNumValues()

Obtain number of distinct value groups in the column. this number is also the number of bitmaps, since there is one bitmap per value

Returns:
  number of distinct value groups in the column;

#### sortValuesByFrequency

    public abstract void sortValuesByFrequency()

#### getNumNonZerosInOffset

    public abstract int getNumNonZerosInOffset(int idx)

#### getNumColumns

    public abstract int getNumColumns()

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`